//+------------------------------------------------------------------+
//|                                                        Bulls.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 2 //<------- I want to add a Moving Average so I guess this needs increasing to 2?
#property indicator_color1 Silver
#property indicator_color2 Yellow  // Better to set color here
#property indicator_width1 1
#property indicator_width2 2  // better to set width here

//#property indicator_minimum -1.0 // <-------I have added this to show minimum value in range 
//#property indicator_maximum 1.0 // <-------I have added this to show maximum value in range 
#property indicator_level1 0.0004 // <-------I have added this to show in the levels tab and also on the Indicator separate chart 
//---- input parameters
extern int BullsPeriod=13;
extern int MAPeriod = 9;
extern string  m = "--Moving Average Types--";
extern string  m0 = " 0 = SMA";
extern string  m1 = " 1 = EMA";
extern string  m2 = " 2 = SMMA";
extern string  m3 = " 3 = LWMA";
extern int       MAType=0;
string strMAType;

//---- buffers
double BullsBuffer[];
double MABuffer[]; //<- I have added this buffer for handling the MA line
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorDigits(Digits);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);             //<-- I added this but not proceed past this point
   SetIndexBuffer(0,BullsBuffer);
   SetIndexBuffer(1,MABuffer);
   
   switch (MAType)
   {
      case 1: strMAType="EMA"; break;
      case 2: strMAType="SMMA"; break;
      case 3: strMAType="LWMA"; break;
      default: strMAType="SMA"; break;
   }
   SetIndexLabel(1, strMAType + "(" + MAPeriod + ")");                   //<-- I added this but not proceed past this point
//---- name for DataWindow and indicator subwindow label
   short_name="Bulls("+BullsPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bulls Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=BullsPeriod) return(0);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      BullsBuffer[i]=High[i] - iMA(NULL,0,BullsPeriod,0,MODE_EMA,PRICE_CLOSE,i);
//----
// MA of Bulls

   for(i=0; i<limit; i++)
      MABuffer[i]=iMAOnArray(BullsBuffer,Bars,MAPeriod,0,MAType,i);
//----
   return(0);
  }
//+------------------------------------------------------------------+


